//*************************************************************
//  Refresh The UI (Full size Reconstruction, Details, Buttons)
//*************************************************************
function RefreshUI()
{			
	//>> Populate Variables
	RetrieveData();
		
	RadioVol = System.Gadget.Settings.read("RadioVol");
	if (RadioVol == "")
		RadioVol = 50;
		
	FavList = System.Gadget.Settings.read("FavList");
	
	//*************************************************************
	//  Variable Interface (Login Panel / Logged In UI)
	//*************************************************************	
	System.Gadget.document.body.style.height = "130px";
	System.Gadget.document.body.style.background = "url('Images/Misc/BGMain.png') no-repeat";
	
	//>>  UI Construction
	uiString = '<div id="StationInfo"></div>';
	uiString += '<div id="ChanBHelper" style="display:none;"></div>';
	uiString += '<div id="VolumeID" style="display:none;"></div>';
	uiString += '<div id="MainButtons"></div>';
	
	System.Gadget.document.getElementById("GadgetContent").innerHTML = uiString;
	
	var TempUI = '<div id="ChanNoChan"></div>';
	TempUI += '<div id="ChanTitle"></div>';
	TempUI += '<div id="ChanArtist"></div>';
	TempUI += '<div id="ChanTrack"></div>';
	TempUI += '<div id="ChanAlbum"></div>';
	System.Gadget.document.getElementById("StationInfo").innerHTML = TempUI;
	
	TempUI = '<div id="UIButtonChanDark"></div>';
	TempUI += '<div id="UIButtonPlayDark"></div>';
	TempUI += '<div id="UIButtonStopDark"></div>';
	TempUI += '<div id="UIButtonMuteDark"></div>';
	TempUI += '<div id="UIButtonPlusDark"></div>';
	TempUI += '<div id="UIButtonVolUpDark"></div>';
	TempUI += '<div id="UIButtonVolDownDark"></div>';
	TempUI += '<div id="UIButtonNextDark"></div>';
	TempUI += '<div id="UIButtonBackDark"></div>';
	
	TempUI += '<div id="UIButtonChan" onclick="ToggleFlyoutChannels();" onmouseover="ChanButtonHelp(\'Channel List\');" onmouseout="ChanButtonHelp(\'\');" title="Channels"></div>';
	TempUI += '<div id="UIButtonPlay" onclick="BeginPlaying();" onmouseover="ChanButtonHelp(\'Play\');" onmouseout="ChanButtonHelp(\'\');" title="Play"></div>';
	TempUI += '<div id="UIButtonStop" onclick="StopPlaying();" onmouseover="ChanButtonHelp(\'Stop\');" onmouseout="ChanButtonHelp(\'\');" title="Stop"></div>';
	TempUI += '<div id="UIButtonMute" class="UIButtonMute" onclick="MuteVolume();" onmouseover="ChanButtonHelp(\'Mute\');" onmouseout="ChanButtonHelp(\'\');" title="Mute"></div>';
	TempUI += '<div id="UIButtonPlus" onclick="AddToFav();" onmouseover="ChanButtonHelp(\'Add To Favs\');" onmouseout="ChanButtonHelp(\'\');" title="Add To Favorites"></div>';
	TempUI += '<div id="UIButtonVolUp" onclick="VolumeUp();" onmouseover="ChanButtonHelp(\'Volume +\');" onmouseout="ChanButtonHelp(\'\');" title="Volume +"></div>';
	TempUI += '<div id="UIButtonVolDown" onclick="VolumeDown();" onmouseover="ChanButtonHelp(\'Volume -\');" onmouseout="ChanButtonHelp(\'\');" title="Volume -"></div>';
	TempUI += '<div id="UIButtonNext" onclick="SongUp();" onmouseover="ChanButtonHelp(\'Next Song\');" onmouseout="ChanButtonHelp(\'\');" title="Next Song"></div>';
	TempUI += '<div id="UIButtonBack" onclick="SongDown();" onmouseover="ChanButtonHelp(\'Prev Song\');" onmouseout="ChanButtonHelp(\'\');" title="Prev Song"></div>';
	System.Gadget.document.getElementById("MainButtons").innerHTML = TempUI;
	
	if (ChanSelect == "")
	{
		System.Gadget.document.getElementById("ChanNoChan").innerHTML = '<br /><div id="ChanListLink" onclick="ToggleFlyoutChannels()" title="Select A Channel">Click To See<br />Channel List</div>';
		System.Gadget.document.getElementById("ChanNoChan").style.display = "block";
		
		System.Gadget.document.getElementById("UIButtonChan").style.display = "none";
		System.Gadget.document.getElementById("UIButtonPlay").style.display = "none";
		System.Gadget.document.getElementById("UIButtonStop").style.display = "none";
		System.Gadget.document.getElementById("UIButtonMute").style.display = "none";
		System.Gadget.document.getElementById("UIButtonPlus").style.display = "none";
		System.Gadget.document.getElementById("UIButtonVolUp").style.display = "none";
		System.Gadget.document.getElementById("UIButtonVolDown").style.display = "none";
		System.Gadget.document.getElementById("UIButtonNext").style.display = "none";
		System.Gadget.document.getElementById("UIButtonBack").style.display = "none";
	}
		
	BuildChannels();
}

//*************************************************************
//  Check Specified Flyouts & Close
//*************************************************************
function CheckToggleFlyout()
{
	if (System.Gadget.Flyout.show == true)
	{			
		if (System.Gadget.Settings.read("FlyoutFile") == "Flyouts/ToggleChannels.html")
			System.Gadget.Flyout.show = false;
	}
	
	if (ChanSelect != "")
	{
		System.Gadget.document.getElementById("UIButtonPlus").style.display = "block";
		CheckFav();
	}
}

//*************************************************************
//  Toggle Channels Flyout
//*************************************************************
function ToggleFlyoutChannels()
{
	if (System.Gadget.Flyout.show == false)
	{		
		System.Gadget.Flyout.file = "Flyouts/ToggleChannels.html";
		System.Gadget.Settings.write("FlyoutFile", "Flyouts/ToggleChannels.html");
		System.Gadget.Flyout.show = true;
	}
	else
		System.Gadget.Flyout.show = false;	
}

//*************************************************************
//  Station Prep
//*************************************************************
function ChangeToStation(ChanID)
{	
	System.Gadget.document.getElementById("UIButtonChan").style.display = "block";
	System.Gadget.document.getElementById("UIButtonPlay").style.display = "block";
	System.Gadget.document.getElementById("UIButtonStop").style.display = "block";
	System.Gadget.document.getElementById("UIButtonMute").style.display = "block";
	System.Gadget.document.getElementById("UIButtonPlus").style.display = "block";
	System.Gadget.document.getElementById("UIButtonVolUp").style.display = "block";
	System.Gadget.document.getElementById("UIButtonVolDown").style.display = "block";
	System.Gadget.document.getElementById("UIButtonNext").style.display = "block";
	System.Gadget.document.getElementById("UIButtonBack").style.display = "block";
	
	System.Gadget.document.getElementById("ChanArtist").innerHTML = '';
	System.Gadget.document.getElementById("ChanTrack").innerHTML = '';
	System.Gadget.document.getElementById("ChanAlbum").innerHTML = '';
				
	System.Gadget.document.getElementById("ChanArtist").title = '';
	System.Gadget.document.getElementById("ChanTrack").title = '';
	System.Gadget.document.getElementById("ChanAlbum").title = '';
	
	System.Gadget.Flyout.show = false;
	System.Gadget.Settings.write("StopFlag", "Go");
	System.Gadget.Settings.write("ChanSelect", ChanID);	
	GetStation(ChanID);
}

//*************************************************************
//  Change To Selected Station
//*************************************************************
function GetStation(ChanID)
{
	var ChanTitleInfo = ChanID + "Title";
	ChanTitleInfo = System.Gadget.document.getElementById(ChanTitleInfo).innerHTML;
	var ChanTitleFeed = ChanID + "Feed";
	ChanTitleFeed = System.Gadget.document.getElementById(ChanTitleFeed).innerHTML;
	System.Gadget.document.getElementById("ChanNoChan").style.display = "none";
	System.Gadget.document.getElementById("ChanArtist").innerHTML = "Getting Info...";
	System.Gadget.document.getElementById("ChanTitle").innerHTML = "<small>" + Ellipse(ChanTitleInfo) + "</small>";
	System.Gadget.document.getElementById("ChanTitle").title = ChanTitleInfo.replace(/&amp;/gi, "&");
		
	try {
		URL = ChanTitleFeed; 
		Req = new XMLHttpRequest();
		Req.open("get", URL, true);	
		Req.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
		Req.onreadystatechange = ProcessStation;
		Req.send(null);
	}
	catch(e){}
}

//*************************************************************
//  Process Station Info
//*************************************************************
function ProcessStation()
{   
	if (Req.readyState == null)
		return;
	if (Req.readyState == 4)
	{
		if (Req.status == 200)
		{
			try
			{
				LoadXML(Req.responseXML);
				
				var xFile = XMLDoc.getElementsByTagName("channel")[0];
				var xTemp = xFile.getElementsByTagName("item");
				
				TrackCount = xTemp.length;
				
				System.Gadget.Settings.write("CurrSong", 0);
				System.Gadget.Settings.write("TrackCount", TrackCount);
				
				i = 0;
				x = '';
				
				while (i < xTemp.length)
				{
					var xTemp2 = xTemp[i];
					var qURL = xTemp2.getElementsByTagName("songplaylink")[0].text;				
					var qArtist = xTemp2.getElementsByTagName("bandname")[0].text;
					var qTrack = xTemp2.getElementsByTagName("songname")[0].text;
					var qAlbum = xTemp2.getElementsByTagName("songalbum")[0].text;
					var qLink = xTemp2.getElementsByTagName("bandurl")[0].text;
					var qMP3Link = xTemp2.getElementsByTagName("songdownloadlink")[0].text;
					
					x += '<div id="Temp'+i+'URL">'+qURL+'</div>';
					x += '<div id="Temp'+i+'Artist">'+qArtist+'</div>';
					x += '<div id="Temp'+i+'Track">'+qTrack+'</div>';
					x += '<div id="Temp'+i+'Album">'+qAlbum+'</div>';
					x += '<div id="Temp'+i+'Link">'+qLink+'</div>';
					x += '<div id="Temp'+i+'MP3Link">'+qMP3Link+'</div>';
					
					i++;
				}
				
				System.Gadget.document.getElementById("TempHolder").innerHTML = x;
				if (x == '')
					System.Gadget.document.getElementById("ChanArtist").innerHTML = "No Songs";
				else
					PlayStation();
			}
			catch(err){}
		}
		else
		{
			if (Req.status == null)
				return;
		}
	}
}

//*************************************************************
//  Play Song From Station
//*************************************************************
function PlayStation()
{
	CurrSong = System.Gadget.Settings.read("CurrSong");
	if (CurrSong == '')
		CurrSong = 0;
	TrackCount = System.Gadget.Settings.read("TrackCount");
	
	if (CurrSong == TrackCount)
		CurrSong = 0;
	if (CurrSong < 0)
		CurrSong = (TrackCount-1);
		
	var qURL = System.Gadget.document.getElementById("Temp"+CurrSong+"URL").innerHTML;
	var qArtist = System.Gadget.document.getElementById("Temp"+CurrSong+"Artist").innerHTML;
	var qTrack = System.Gadget.document.getElementById("Temp"+CurrSong+"Track").innerHTML;
	//var qAlbum = System.Gadget.document.getElementById("Temp"+CurrSong+"Album").innerHTML;
	var qArtLink = System.Gadget.document.getElementById("Temp"+CurrSong+"Link").innerHTML;
	var qMP3Link = System.Gadget.document.getElementById("Temp"+CurrSong+"MP3Link").innerHTML;
	qMP3Link = qMP3Link.replace(/&amp;/gi, "&");
	
	var qArtistHTML = '<span class="ArtistLink" onmouseover="ChanButtonHelp(\'Visit This Artist\');" onmouseout="ChanButtonHelp(\'\');" onclick="Shell.Run(\''+qArtLink+'\');">' + Ellipse(qArtist) + '</span>';
	
	System.Gadget.document.getElementById("ChanArtist").innerHTML = qArtistHTML;
	System.Gadget.document.getElementById("ChanTrack").innerHTML = '"' + Ellipse(qTrack) + '"';
	System.Gadget.document.getElementById("ChanArtist").title = qArtist;
	System.Gadget.document.getElementById("ChanTrack").title = qTrack;
	
	if (qMP3Link != '')
	{
		var qMP3HTML = '<span class="SongLink" onclick="Shell.Run(\''+qMP3Link+'\');">Download MP3</span>';
		System.Gadget.document.getElementById("ChanAlbum").innerHTML = qMP3HTML;
		System.Gadget.document.getElementById("ChanAlbum").title = "Download MP3";
	}
	else
	{
		var qArtHTML = '<span class="SongLink" onclick="Shell.Run(\''+qArtLink+'\');">Visit This Artist</span>';
		System.Gadget.document.getElementById("ChanAlbum").innerHTML = qArtHTML;
		System.Gadget.document.getElementById("ChanAlbum").title = "Visit This Artist";
	}
	
	qURL = qURL.replace(/&amp;/gi, "&");
	
	RadioVol = System.Gadget.Settings.read("RadioVol");
	if (RadioVol == "")
		RadioVol = 50;
	
	x = '<OBJECT id="MediaPlayer" name="mediaplayer" width="320" height="240" CLASSID="CLSID:6BF52A52-394A-11d3-B153-00C04F79FAA6" type="application/x-oleobject">';
	x += '<PARAM NAME="URL" VALUE="'+qURL+'">';
	x += '<PARAM NAME="AutoStart" VALUE="True">';
	x += '<PARAM name="uiMode" value="none">';
	x += '<PARAM name="PlayCount" value="1">';
	x += '<PARAM NAME="SendPlayStateChangeEvents" VALUE="True">';
	x += '<PARAM name="Volume" value="'+RadioVol+'">';
	x += '</OBJECT>';
	System.Gadget.document.getElementById("PlayerHolder").innerHTML = x;
	System.Gadget.document.MediaPlayer.controls.play();
	
	if (System.Gadget.document.getElementById("UIButtonMute").className == 'UIButtonMuteGlow')
		System.Gadget.document.MediaPlayer.settings.Volume = 0;
					
	if (System.Gadget.Settings.read("StopFlag") != "Stop")
		System.Gadget.document.getElementById("UIButtonPlay").style.display = "none";
	System.Gadget.Settings.write("ActFlag", 'NoAction');
}

//*************************************************************
//  Check Player For Stop & Go To Next Track If Stopped
//*************************************************************
function CheckPlayer()
{	
	if (System.Gadget.Settings.read("StopFlag") != "Stop" && System.Gadget.Settings.read("ActFlag") != "Action" && System.Gadget.document.MediaPlayer.PlayState == 8)
	{
		SongUp();
	}
}

//*************************************************************
//  Cut String Down To Manageable Size
//*************************************************************
function Ellipse(Trimmed) {
        if (Trimmed.length > 20) {
            return(Trimmed.substring(0,17)+"...");
        } else {
            return(Trimmed);
        }
}

//*************************************************************
//  Temporarily Stop Playing
//*************************************************************
function StopPlaying()
{
    System.Gadget.document.getElementById("ChanArtist").innerHTML = "Stopped";
    System.Gadget.document.getElementById("UIButtonPlay").style.display = "block";
	System.Gadget.document.getElementById("UIButtonStop").style.display = "none";
	System.Gadget.Settings.write("StopFlag", "Stop");
	System.Gadget.Settings.write("ActFlag", "Action");
	
	MediaPlayer.controls.stop();

	System.Gadget.document.getElementById("ChanTrack").innerHTML = "";
	System.Gadget.document.getElementById("ChanAlbum").innerHTML = "";
	CheckFav();
}

//*************************************************************
//  Resume Playing
//*************************************************************
function BeginPlaying()
{
	System.Gadget.document.getElementById("UIButtonStop").style.display = "block";
	CurrSong = System.Gadget.Settings.read("CurrSong");
	System.Gadget.Settings.write("StopFlag", "Go");
	System.Gadget.Settings.write("ActFlag", "Action");
	PlayStation();
	CheckFav();
}

//*************************************************************
//  Volume Up
//*************************************************************
function VolumeUp()
{
	RadioVol = parseInt(System.Gadget.Settings.read("RadioVol"));
	var RadioTemp = RadioVol + 10;
	if (RadioTemp >= 100)
		RadioTemp = 100;
		
	MediaPlayer.settings.Volume = RadioTemp;
	System.Gadget.Settings.write("RadioVol", RadioTemp);
	System.Gadget.document.getElementById("StationInfo").style.display = "none";
	System.Gadget.document.getElementById("VolumeID").innerHTML = "Vol: " + RadioTemp + "%";
	System.Gadget.document.getElementById("VolumeID").style.display = "block";
	
	setTimeout("System.Gadget.document.getElementById('StationInfo').style.display = 'block'; System.Gadget.document.getElementById('VolumeID').style.display = 'none';",1000);

	SaveData();
}

//*************************************************************
//  Volume Down
//*************************************************************
function VolumeDown()
{
	RadioVol = System.Gadget.Settings.read("RadioVol");
	var RadioTemp = RadioVol - 10;
	if (RadioTemp <= 0)
		RadioTemp = 0;
		
	MediaPlayer.settings.Volume = RadioTemp;
	System.Gadget.Settings.write("RadioVol", RadioTemp);
	System.Gadget.document.getElementById("StationInfo").style.display = "none";
	System.Gadget.document.getElementById("VolumeID").innerHTML = "Vol: " + RadioTemp + "%";
	System.Gadget.document.getElementById("VolumeID").style.display = "block";
	
	setTimeout("System.Gadget.document.getElementById('StationInfo').style.display = 'block'; System.Gadget.document.getElementById('VolumeID').style.display = 'none';",1000);
	
	SaveData();
}

//*************************************************************
//  Add To Favorites
//*************************************************************
function AddToFav()
{
	FavList = System.Gadget.Settings.read("FavList");
	ChanSelect = System.Gadget.Settings.read("ChanSelect");

	FavList = ChanSelect + "|" + FavList;
		
	System.Gadget.Settings.write("FavList", FavList);
	
	System.Gadget.document.getElementById("UIButtonPlus").style.display = "none";
	
	System.Gadget.document.getElementById("StationInfo").style.display = "none";
	System.Gadget.document.getElementById("VolumeID").innerHTML = "Fav +";
	System.Gadget.document.getElementById("VolumeID").style.display = "block";
	
	setTimeout("System.Gadget.document.getElementById('StationInfo').style.display = 'block'; System.Gadget.document.getElementById('VolumeID').style.display = 'none';",1000);
	
	SaveData();
}

//*************************************************************
//  Check Favorites
//*************************************************************
function CheckFav()
{
	FavList = System.Gadget.Settings.read("FavList");
	ChanSelect = System.Gadget.Settings.read("ChanSelect");

	var FavCheck = FavList.split("|");
	var i = 0;
	while (i < FavCheck.length)
	{
		if (FavCheck[i] == ChanSelect)
			System.Gadget.document.getElementById("UIButtonPlus").style.display = "none";
		i++;
	}
	
	if (ChanSelect == "")
		System.Gadget.document.getElementById("UIButtonPlus").style.display = "none";
}

//*************************************************************
//  Channel Button Helper
//*************************************************************
function ChanButtonHelp(Stuff)
{
	if (Stuff != "")
	{
		System.Gadget.document.getElementById("ChanAlbum").style.display = "none";
		System.Gadget.document.getElementById("ChanBHelper").innerHTML = "<span class='Stuff'>" + Stuff + "</span>";
		System.Gadget.document.getElementById("ChanBHelper").style.display = "block";
	}
	
	if (Stuff == "")
	{
		System.Gadget.document.getElementById("ChanAlbum").style.display = "block";
		System.Gadget.document.getElementById("ChanBHelper").innerHTML = "";
		System.Gadget.document.getElementById("ChanBHelper").style.display = "none";
	}
}

//*************************************************************
//  Mute Volume
//*************************************************************
function MuteVolume()
{
	if (System.Gadget.document.getElementById("UIButtonMute").className == 'UIButtonMute')
	{
		System.Gadget.document.MediaPlayer.settings.Volume = 0;
		System.Gadget.document.getElementById("UIButtonMute").className = "UIButtonMuteGlow";
		System.Gadget.document.getElementById("StationInfo").style.display = "none";
		System.Gadget.document.getElementById("VolumeID").innerHTML = "Muted";
		System.Gadget.document.getElementById("VolumeID").style.display = "block";
		setTimeout("System.Gadget.document.getElementById('StationInfo').style.display = 'block'; System.Gadget.document.getElementById('VolumeID').style.display = 'none';",1000);
	}
	else
	{
		RadioVol = System.Gadget.Settings.read("RadioVol");
		System.Gadget.document.MediaPlayer.settings.Volume = RadioVol;
		System.Gadget.document.getElementById("UIButtonMute").className = 'UIButtonMute';
		System.Gadget.document.getElementById("StationInfo").style.display = "none";
		System.Gadget.document.getElementById("VolumeID").innerHTML = "Un-Muted";
		System.Gadget.document.getElementById("VolumeID").style.display = "block";
		setTimeout("System.Gadget.document.getElementById('StationInfo').style.display = 'block'; System.Gadget.document.getElementById('VolumeID').style.display = 'none';",1000);
	}
}

//*************************************************************
//  Song Forward
//*************************************************************
function SongUp()
{
	System.Gadget.document.MediaPlayer.URL = '';
	CurrSong = System.Gadget.Settings.read("CurrSong");
	CurrSong++;
	
	TrackCount = System.Gadget.Settings.read("TrackCount");
	
	if (CurrSong == TrackCount)
		CurrSong = 0;
	
	System.Gadget.Settings.write("CurrSong", CurrSong);	
	System.Gadget.Settings.write("ActFlag", "Action");
	
	System.Gadget.document.getElementById("StationInfo").style.display = "none";
	System.Gadget.document.getElementById("VolumeID").innerHTML = "Song " + (CurrSong+1);
	System.Gadget.document.getElementById("VolumeID").style.display = "block";
	setTimeout("System.Gadget.document.getElementById('StationInfo').style.display = 'block'; System.Gadget.document.getElementById('VolumeID').style.display = 'none';",1000);
	
	PlayStation();
}

//*************************************************************
//  Song Backward
//*************************************************************
function SongDown()
{
	System.Gadget.document.MediaPlayer.URL = '';
	CurrSong = System.Gadget.Settings.read("CurrSong");
	CurrSong--;
	
	TrackCount = System.Gadget.Settings.read("TrackCount");
	
	if (CurrSong < 0)
		CurrSong = (TrackCount-1);
	
	System.Gadget.Settings.write("CurrSong", CurrSong);	
	System.Gadget.Settings.write("ActFlag", "Action");
	
	System.Gadget.document.getElementById("StationInfo").style.display = "none";
	System.Gadget.document.getElementById("VolumeID").innerHTML = "Song " + (CurrSong+1);
	System.Gadget.document.getElementById("VolumeID").style.display = "block";
	setTimeout("System.Gadget.document.getElementById('StationInfo').style.display = 'block'; System.Gadget.document.getElementById('VolumeID').style.display = 'none';",1000);
	
	PlayStation();
}

//*************************************************************
//  Save Data
//*************************************************************
function SaveData()
{		
	RadioVol = System.Gadget.Settings.read("RadioVol");
	if (RadioVol == "")
		RadioVol = 50;
		
	FavList = System.Gadget.Settings.read("FavList");
	
	try{
		var sPath = System.Gadget.path;
		var sPos = System.Gadget.path.lastIndexOf("\\");
		var sFilename = sPath.substr(0,sPos) + "\\UBWRadioData.xml";
		var xString = "";
		if (oFSO.FileExists(sFilename))
		{
			oFSO.DeleteFile(sFilename, true);
		}
		var oFile = oFSO.CreateTextFile(sFilename, true);
		
		xString += '<?xml version="1.0" ?>';
		xString += '<Settings>';
		
		xString += '<General>';
		xString += '<RadioVol>' + RadioVol + '</RadioVol>';
		xString += '<FavList>' + FavList + '</FavList>';
		xString += '</General>';
		
		xString += '</Settings>';
		
		oFile.WriteLine(xString);
		oFile.Close();
	} 
	catch(err) {
		Debug(err);
	}
}

//*************************************************************
//  Retrieve Data
//*************************************************************
function RetrieveData()
{
	try{
		var sPath = System.Gadget.path;
		var sPos = System.Gadget.path.lastIndexOf("\\");
		var sFilename = sPath.substr(0,sPos) + "\\UBWRadioData.xml";
		if (oFSO.FileExists(sFilename))
		{
			LoadXML(sFilename);
			var xFile = XMLDoc.getElementsByTagName("Settings")[0];
			var xFileGen = xFile.getElementsByTagName("General")[0];
			
			System.Gadget.Settings.write("RadioVol", xFileGen.getElementsByTagName("RadioVol")[0].text);
			System.Gadget.Settings.write("FavList", xFileGen.getElementsByTagName("FavList")[0].text);
		}
		else
		{
			SaveData();
			RetrieveData();
		}
	} 
	catch(err) {
		System.Gadget.document.getElementById("GadgetContent").innerHTML= "<small>File I/O Error</small>";
	}
}

//*************************************************************
//  Debug Data
//*************************************************************
function Debug(Data)
{	
	try{
		var sPath = System.Gadget.path;
		var sPos = System.Gadget.path.lastIndexOf("\\");
		var sFilename = sPath.substr(0,sPos) + "\\UBWRadioDebug.txt";
		var xString = "";
		if (oFSO.FileExists(sFilename))
			oFSO.DeleteFile(sFilename, true);
		var oFile = oFSO.CreateTextFile(sFilename, true);
		xString += Data;
		oFile.WriteLine(xString);
		oFile.Close();
	} 
	catch(err) {}
}